package ActiveState::Transformer::Pipeline;
use strict;

sub new {
    my $class = shift;
    my $self = bless {}, $class;
    $self->{transformer_plugins} = shift;
    return $self;
}

sub transform {
    my $self = shift;
    my $input = shift;
    for my $transformer_plugin (@{$self->{transformer_plugins}}) {
	$input = $transformer_plugin->transform($input);
    }
    return $input;
}

1;
