package ActiveState::Transformer::Plugin::StripCharacterRange;
use strict;
use base qw(ActiveState::Transformer::Plugin);

# TODO: Split char class range entry parsing into a shared package

sub new  {
    my $self = ActiveState::Transformer::Plugin::new(@_);
    my $class = shift;
    my $opts = shift;
    if ($opts) {
	my ($from, $to) = split /\s*-\s*/, $opts, 2;

	$self->{cc} = "[$from-$to]";
    }

    return $self;
}

sub to_charclass_hex {
    my $number = shift;
    return undef unless $number;

    if ($number =~ /^\\?x([\dA-F]{2})$/i) {
	return "\\x$1";
    }

    if ($number =~ /^(\d+)$/) {
	if ($1 < 256) {
	    return sprintf("\\x%02X", $1);
	}
    }

    if ($number =~ /^U+\d/) {
	# we don't have support for UNICODE in 5.6
	# maybe PCRE will have it?
	return undef;
    }

    return undef;
}

# class method
sub normalize_parameters {
    my $opts = shift;
    $opts =~ s/^\s+//;
    $opts =~ s/\s+$//;

    my ($from, $to) =
	 map { to_charclass_hex($_) }
	 split /\s*-\s*/, $opts, 2;

    return undef unless $from && $to;

    return "$from-$to";
}

sub transform {
    my $self = shift;
    my $temp = shift;
    $temp =~ s/$self->{cc}//g if $self->{cc};
    return $temp;
}

1;
