package ActiveState::Transformer::Plugin::TranslateHighBit;
use strict;
use base qw(ActiveState::Transformer::Plugin);

our $TRANSLATION_TABLE;
{
    my @s;
    $s[$_] = chr($_) for (0x00..0xff);
    $s[0x83] = 'f';
    $s[0x86] = 't';
    $s[0x8A] = 's';
    $s[0x8C] = 'e';
    $s[0x99] = 't';
    $s[0x9F] = 'y';
    $s[0xa1] = 'i';
    $s[0xa2] = 'c';
    $s[0xa3] = 'f';
    $s[0xa5] = 'y';
    $s[0xa6] = 'i';
    $s[0xa7] = 's';
    $s[0xa9] = 'c';
    $s[0xaa] = 'a';
    $s[0xae] = 'r';
    $s[0xb2] = '2';
    $s[0xb3] = '3';
    $s[0xb5] = 'u';
    $s[0xb9] = '1';
    $s[0xba] = '0';
    $s[0xc0] = 'a';
    $s[0xc1] = 'a';
    $s[0xc2] = 'a';
    $s[0xc3] = 'a';
    $s[0xc4] = 'a';
    $s[0xc5] = 'a';
    $s[0xc6] = 'e';
    $s[0xc7] = 'c';
    $s[0xc8] = 'e';
    $s[0xc9] = 'e';
    $s[0xca] = 'e';
    $s[0xcb] = 'e';
    $s[0xcc] = 'i';
    $s[0xcd] = 'i';
    $s[0xce] = 'i';
    $s[0xcf] = 'i';
    $s[0xd0] = 'd';
    $s[0xd1] = 'n';
    $s[0xd2] = 'o';
    $s[0xd3] = 'o';
    $s[0xd4] = 'o';
    $s[0xd5] = 'o';
    $s[0xd6] = 'o';
    $s[0xd7] = 'x';
    $s[0xd8] = 'o';
    $s[0xd9] = 'u';
    $s[0xda] = 'u';
    $s[0xdb] = 'u';
    $s[0xdc] = 'u';
    $s[0xdd] = 'y';
    $s[0xde] = 'p';
    $s[0xdf] = 'b';
    $s[0xe0] = 'a';
    $s[0xe1] = 'a';
    $s[0xe2] = 'a';
    $s[0xe3] = 'a';
    $s[0xe4] = 'a';
    $s[0xe5] = 'a';
    $s[0xe6] = 'e';
    $s[0xe7] = 'c';
    $s[0xe8] = 'e';
    $s[0xe9] = 'e';
    $s[0xea] = 'e';
    $s[0xeb] = 'e';
    $s[0xec] = 'i';
    $s[0xed] = 'i';
    $s[0xee] = 'i';
    $s[0xef] = 'i';
    $s[0xf0] = 'o';
    $s[0xf1] = 'n';
    $s[0xf2] = 'o';
    $s[0xf3] = 'o';
    $s[0xf4] = 'o';
    $s[0xf5] = 'o';
    $s[0xf6] = 'o';
    $s[0xf8] = 'o';
    $s[0xf9] = 'u';
    $s[0xfa] = 'u';
    $s[0xfb] = 'u';
    $s[0xfc] = 'u';
    $s[0xfd] = 'y';
    $s[0xfe] = 'p';
    $s[0xff] = 'y';
    $TRANSLATION_TABLE=\@s;
}
    
sub transform {
    my $self = shift;
    my $temp = shift;
    $temp =~ s/([\x80-\xff])/$TRANSLATION_TABLE->[ord($1)]/gex;
    return $temp;
}

1;
